<template>
  <q-chip
      clickable
      :label="labelChip"
      :color="colorChip && 'primary' || 'red'"
      :outline="outlineChip"
      :text-color="textColorChip"
      :disable="!isAuth"
      :class="{'pointer-events-none':!isAuth}"
  >
    <q-menu anchor="center middle"
            self="center middle"
            max-height="250px"
            class="p-2"
    >
      <q-select
          v-model="modelSelect"
          :model-value="tempLabel"
          dense
          row-key="name"
          option-label="name"
          :options="options"
          @filter="filterTasks"
          map-options
          use-input
      >
        <template v-slot:option="{ itemProps, opt, selected, toggleOption }">
          <q-item v-bind="itemProps" :class="{'bg-orange-200':opt.pin}">
            <q-item-section @click="selectTask({name: opt.name, _id: opt._id})">
              <q-item-label v-close-popup v-html="opt.name" />
            </q-item-section>
            <q-btn v-if="!opt.pin" @click.stop="pinTaskOnList({name: opt.name, _id: opt._id})" size="sm" round flat icon="push_pin" class="opacity-20 hover:opacity-70">
              <q-tooltip>Закрепить</q-tooltip>
            </q-btn>
            <q-btn v-else @click.stop="unpinTaskOnList({name: opt.name, _id: opt._id})" size="sm" round flat icon="push_pin">
              <q-tooltip>Открепить</q-tooltip>
            </q-btn>
          </q-item>
        </template>
        <template v-slot:no-option>
          <q-item>
            <q-item-section class="text-grey">
              Нет результатов
            </q-item-section>
          </q-item>
        </template>
      </q-select>
    </q-menu>
  </q-chip>
</template>

<script>
import {ref} from "vue";
import api from "../API/api";
import {useRoute} from "vue-router";
import useTranslitRoles from "./useTranslitRoles";
import {useStore} from "vuex";

let stringOptions = [].reduce((acc, opt) => {
  for (let i = 1; i <= 5; i++) {
    acc.push(opt + ' ' + i)
  }
  return acc
}, [])

export default {
  name: "TaskSelected",
  props: {
    labelChip: {type: String, required: false},
    colorChip: {type: String, required: false},
    outlineChip: {type: Boolean, required: false},
    textColorChip: {type: String, required: false},
    optionLabelSelect: {type: String, required: false},
    modelSelect: {required: true},
    modelValue: {type: String, required: true},
    labelSelect: {required: false},
  },
  setup (props, {emit}) {

    const route = useRoute();
    const tasks = ref([])
    const options = ref([])
    const store = useStore()
    const isAuth = store.getters.isAuth
    const tempLabel = ref(props.labelChip)

    async function getTasks () {
      tasks.value = []
      options.value = []


      await api.getTasks()
          .then(res => {
            tasks.value = [...res.data.tasks]
          })
    }

    async function selectTask (task) {
      tempLabel.value = task.name
      emit('selectTask', tempLabel.value)
    }

    async function filterTasks (val, update, abort) {
      tempLabel.value = ''
      options.value = []
      stringOptions = []
      options.value.length || await api.getTasks().then(res => {
        const myArr = res.data.tasks.map(obj => {
          const { name, _id } = obj; // Оставляем только свойства name и _id
          return { name, _id };
        })
        stringOptions = stringOptions.concat(myArr)
      })

      update(() => {
        const needle = val.toLocaleLowerCase()
        options.value = stringOptions.filter(v => v.name.toLocaleLowerCase().indexOf(needle) > -1)
        if (!localStorage.pin_task) localStorage.setItem('pin_task', JSON.stringify([]))
        const pinArr = JSON.parse(localStorage.getItem('pin_task'))
        options.value.filter(el => {
          const isFound = pinArr.includes(el._id);
          if (isFound) {
            el.pin = true;
            // Удалить obj1 из текущего индекса
            const index = options.value.indexOf(el);
            options.value.splice(index, 1);
            // Добавить obj1 в начало массива
            options.value.unshift(el);
          }
        })
      })
    }
    async function pinTaskOnList (obj) {
      const pinArr = JSON.parse(localStorage.getItem('pin_task'))
      pinArr.push(obj._id)
      options.value.filter(el => {
        if (el._id === obj._id) {
          el.pin = true
          // Удалить obj1 из текущего индекса
          const index = options.value.indexOf(el);
          options.value.splice(index, 1);
          // Добавить obj1 в начало массива
          options.value.unshift(el);
        }
      })
      localStorage.setItem('pin_task', JSON.stringify(pinArr))
    }
    async function unpinTaskOnList (obj) {
      let  pinArr = JSON.parse(localStorage.getItem('pin_task'))
      pinArr = pinArr.filter(el => el !== obj._id)
      options.value.filter(el => {
        if (el._id === obj._id) el.pin = false
      })
      localStorage.setItem('pin_task', JSON.stringify(pinArr))
    }

    return {
      tasks,
      options,
      isAuth,
      getTasks,
      selectTask,
      filterTasks,

      pinTaskOnList,
      unpinTaskOnList,

      useTranslitRoles,
      tempLabel
    }

  }
}
</script>

<style scoped>

</style>
